
class BlockNode extends SourceNode
{
   public boolean syntactic_predicate; // syntactic predicate or EBNF
   public char mark = ' ';             // EBNF mark ( or '>' for syntactic predicate )

   public BlockNode above;   // outer block
   public int alt_count;     // number of alternatives
   public AltNode above_alt; // outer alternative
   public int index;         // index within outer alternative, from 1

   public boolean loop;          // used <add> item
   public boolean subitem_loop;  // simple loop for all subitems
   public boolean braces;        // block of code

   public boolean parenthesis;  // grammar with parenthesis

   public int condition_inx; // index of syntactic predicate function

   public AltNode first_alt;
   public AltNode last_alt;

   /* list */

   public void insertAlt (AltNode item)
   {
      if (first_alt == null)
         first_alt = item;
      else
         last_alt.next_alt = item;

      last_alt = item;
      item.next_alt = null;
   }

}
