
import java.util.Enumeration;

class EnumInfo extends TypeInfo
{
  /* items */

  private DictTable items = new DictTable ();

  public boolean containsItem (String item_name)
  {
    return items.contains (item_name);
  }

  public void createItem (String item_name)
  {
    if (containsItem (item_name))
       err ("Item already defined: " + item_name);

    DictItem item = new DictItem ();
    item.ident = item_name;

    items.store (item);
  }

  public Enumeration getItems ()
  {
    return items.elements ();
  }
}
