
import java.util.Enumeration;
import java.util.Vector;
import java.util.TreeMap;

class LiteralTable extends Common
{
  private TreeMap ident_tree = new TreeMap ();
  private TreeMap text_tree = new TreeMap ();
  private Vector  list = new Vector ();

  public Enumeration elements ()
  {
    return list.elements ();
  }

  public int size ()
  {
    return ident_tree.size ();
  }

  /*
  public boolean empty ()
  {
    return ident_tree.isEmpty ();
  }
  */

  public boolean containsIdent (String ident)
  {
    return ident_tree.containsKey (ident);
  }

  public LiteralItem searchIdent (String ident)
  {
    return (LiteralItem) ident_tree.get (ident);
  }

  public boolean containsText (String text)
  {
     return text_tree.containsKey (text);
  }

  public LiteralItem searchText (String text)
  {
    return (LiteralItem) text_tree.get (text);
  }

  public void store (LiteralItem item)
  {
    ident_tree.put (item.ident, item);
    text_tree.put (item.text, item);
    list.add (item);
  }

}
