
class TextItem
{
   public char key;
   public boolean used;
   public boolean complete;
   public String name;
   public String value;

   public TextItem first;
   public TextItem last;

   public TextItem prev;
   public TextItem next;

   public TextItem up;

   public TextItem getFirst () { return first; }
   public TextItem getLast () { return last; }

   public TextItem getPrev () { return prev; }
   public TextItem getNext () { return next; }

   public void insertLast (TextItem item)
   {
      item.up = this;

      item.prev = last;
      item.next = null;

      if (last == null)
         first = item;
      else
         last.next = item;

      last = item;
   }

   public void insertBefore (TextItem item)
   {
      item.prev = this.prev;
      item.next = this;
      item.up =   this.up;

      if (item.prev == null)
         this.up.first = item;
      else
         item.prev.next = item;

      this.prev = item;
   }

}
