#include <iostream>
#include <fstream>
#include <antlr/ASTRefCount.hpp>
#include "CMMLexer.hpp"
#include "CMMParser.hpp"

using namespace std;

int main()
{
	try 
	{
      #if 0
         ifstream stream ("test.c");
         CMMLexer lexer(stream);
      #else
         CMMLexer lexer(std::cin);
      #endif

	  CMMParser parser(lexer);
	  parser.declaration_list();
	  cout << "O.K." << endl;

	} 
	catch(std::exception& e) 
	{
		std::cerr << "exception: " << e.what() << std::endl;
	}
	return 0;
}
